-------------------------------------------------------------------------
-- FileList
--
-- $Id: FileList.lua,v 1.4 2005/07/14 22:19:44 okayu Exp $
-------------------------------------------------------------------------
LUA_PATH = "./?.lua;./LuaClass/?.lua"
require "LuaClass"
require "Resource"

-- Class name declarations.
begin_declare()
declare("FileList")


-------------------------------------------------------------------------
-- t@CXgNX
-------------------------------------------------------------------------
FileList = { "FileList", "Folder"; class = {} }
	
	function FileList:init( name )
		self.mDependents = Array()			-- ̃f[^Ɉˑr[
		self:super(name or "VKXg")
		self:setSubTreeOpenFlag( true )
	end
	

--~ 	-------------------------------------------------------------
--~ 	-- VACY
--~ 	-------------------------------------------------------------
--~ 	-- VACY
--~ 	-- stream   : io.open() ŊJꂽt@Cnh
--~ 	-- basePath : ΃pXŏoꍇ̓x[XpXB΃pX̏ꍇ nil
--~ 	-- indent   : Cfg
--~ 	function FileList:serialize( stream, basePath, indent )
--~ 		local tab = "  "
--~ 		local spc = string.rep(tab, indent)
--~ 		stream:write(spc..'{ class="FileList";\n')
--~ 		stream:write(spc..tab..'name='..app.safeLiteral(self:name())..';\n')
--~ 		stream:write(spc..tab..'children={\n')
--~ 		self:foreachChild(
--~ 			function ( i, res )
--~ 				res:serialize( stream, basePath, indent + 2 )
--~ 			end
--~ 		)
--~ 		stream:write(spc..tab..'};\n')
--~ 		stream:write(spc..'};\n')
--~ 	end

--~ 	-- fVACY
--~ 	function FileList:deserialize( data )
--~ 		-- e[u珉
--~ 		self:setName( data.name )
--~ 		self:setSubTreeOpenFlag( data.treeOpened )
--~ 		if data.children == nil then return end
--~ 		if table.getn( data.children ) == 1 then
--~ 			-- t@CЂƂ̏ꍇ̓Tuc[ǂݍ
--~ 			local res = Resource:deserialize( data.children[1] )
--~ 			res:loadSubTree()
--~ 			self:addNode( res )
--~ 		else
--~ 			table.foreach( data.children,
--~ 				function (i, child)
--~ 					local res = Resource:deserialize( child )
--~ 					self:addNode( res )
--~ 				end
--~ 			)
--~ 		end
--~ 	end


	-------------------------------------------------------------
	-- \[Xǉ̏
	-------------------------------------------------------------
	-- \[Xǉ̏i[g̃m[ĥݎ󂯎j
	function FileList:onAddDescendant( node )
		if self.mDependents:size() == 0 then return end
	
		-- r[XV
		local row = node:resourceIndex()
		self:changed( FileList.kInsertNode, row, node )

		-- wm[hɂăr[XV
		node:foreachDescendant(
			function( i, v )
				row = row + 1
				self:changed( FileList.kInsertNode, row, v )
			end
		)
	end
	
	
	-- \[Xǉ̏i[g̃m[ĥݎ󂯎j
	function FileList:changeCurrentImage( oldFile, newFile )
		self:changed( FileList.kChangeViewResource, oldFile, gData.imageFile )
	end

	-- Dependency
	function FileList:addDependent( view )
		return self.mDependents:add( view )
	end

	function FileList:removeDependent( view )
		local found = self.mDependents:find( view )
		if found == nil then return nil end
		return self.mDependents:remove( found )
	end

	function FileList:changed( ... )
		local updateArgs = arg
		self.mDependents:foreach(
			function( i, v )
				v:updateModel( unpack(updateArgs) )
			end
		)
	end

	
	function FileList.class:init()
		-- NX萔
		self.kInsertNode = 0
		self.kChangeViewResource = 1
	end


Class:new( FileList )




-------------------------------------------------------------------------
-- end of file
-------------------------------------------------------------------------
end_declare()