-------------------------------------------------------------------------
-- FileListView
-- t@CXg\r[
--
-- $Id: FileListView.lua,v 1.5 2005/07/14 22:19:44 okayu Exp $
-------------------------------------------------------------------------
LUA_PATH = "./?.lua;./LuaClass/?.lua"
require "LuaClass"
require "FileList"

-- Class name declarations.
begin_declare()
declare("GridView")
declare("FileListView")



-- ̎gp󋵊mFp
local print_gcinfo
function print_gcinfo( str )
	local i, t = gcinfo()
	print( "<lua>"..str.." GC : "..i.." / "..t )
end


-- GridView R[obNp̃Ze[u쐬ĕԂ
local cellData
function cellData( _text, _bgColor, _fgColor, _imageIndex, _leftMargin )
	return { text = _text, bgColor = _bgColor, fgColor = _fgColor,
		imageIndex=_imageIndex, leftMargin = _leftMargin }
end


-- TCY\ƕF쐬
local sizeString
function sizeString( size )
	if size == 0 then
		return ""
	elseif size < 1024 then
		return string.format("%d bytes", size)
	elseif size < 1024 * 1024 then
		size = size / 1024
		return string.format("%d KB", size)
	elseif size < 1024 * 1024 * 1024 then
		size = size / (1024 * 1024)
		if size < 10 then
			return string.format("%.1f MB", size), "A00020"
		elseif size < 100 then
			return string.format("%.1f MB", size), "600060"
		end
		return string.format("%d MB", size), "2000A0"
	else
		size = size / (1024 * 1024 * 1024)
		if size < 10 then
			return string.format("%.1f GB", size), "800080"
		elseif size < 100 then
			return string.format("%.1f GB", size), "A000A0"
		end
		return string.format("%d GB", size), "C000C0"
	end
end


-------------------------------------------------------------------------
-- Obhr[NX
-------------------------------------------------------------------------
GridView = { "GridView"; class = {} }

	function GridView:init( gridViewID )
		self.mViewID = gridViewID		-- Obhr[̂hc

		-- CxgnhR[obN֐Ƃēo^
		self:setCallBack {
			onClickCell = self:bind( self.onClickCell );
			onDoubleClickCell = self:bind( self.onDoubleClickCell );
			onRightClickCell = self:bind( self.onRightClickCell );
			onKey = self:bind( self.onKey );
		}
	end

	function GridView:gridViewID()
		return self.mViewID
	end


	-- wZ̃f[^擾Eݒ肷
	function GridView:getFocus()
		return gridview.getFocus( self.mViewID )
	end

	function GridView:setFocus( row )
		gridview.setFocus( self.mViewID, row )
	end

	-- wZ̃f[^擾Eݒ肷
	function GridView:getCellData( row, col )
		return gridview.getCellData( self.mViewID, row, col )
	end

	function GridView:setCellData( row, col, data )
		gridview.setCellData( self.mViewID, row, col, data )
	end

	-- ws̊eZ̃f[^܂Ƃ߂Đݒ肷
	function GridView:setRowData( row, cells )
		table.foreach( cells,
			function(i, v)
				self:setCellData( row, i - 1, v )
			end
		)
	end

	-- ws̎Oɋs}
	function GridView:insertRow( row )
		return gridview.insertRow( self.mViewID, row )
	end

	-- w̎Oɋ}
	function GridView:insertColumn( col )
		return gridview.insertColumn( self.mViewID, col )
	end

	-- ws폜
	function GridView:deleteRow( row )
		return gridview.deleteRow( self.mViewID, row )
	end

	-- w폜
	function GridView:deleteColumn( col )
		return gridview.deleteColumn( self.mViewID, col )
	end

	-- w̍s count sB^\
	function GridView:hideRow( row, count )
		count = count or 1
		return gridview.hideRow( self.mViewID, row, count )
	end

	function GridView:showRow( row, count )
		count = count or 1
		return gridview.showRow( self.mViewID,row, count )
	end

	-- f[^s܂̓f[^̐擾
	function GridView:getDataRowCount()
		return self:getRowCount() - self:getFixedRowCount()
	end

	function GridView:getDataColumnCount()
		return self:getColumnCount() - self:getFixedColumnCount()
	end

	-- s܂͗̐擾Eݒ肷
	function GridView:getRowCount()
		return gridview.getRowCount( self.mViewID )
	end

	function GridView:setRowCount( rows )
		gridview.setRowCount( self.mViewID, rows )
	end

	function GridView:getColumnCount()
		return gridview.getColumnCount( self.mViewID )
	end

	function GridView:setColumnCount( rows )
		gridview.setColumnCount( self.mViewID, rows )
	end

	-- Œ肳ꂽs܂͗̐擾Eݒ肷
	function GridView:getFixedRowCount()
		return gridview.getFixedRowCount( self.mViewID )
	end

	function GridView:setFixedRowCount( rows )
		gridview.setFixedRowCount( self.mViewID, rows )
	end

	function GridView:getFixedColumnCount()
		return gridview.getFixedColumnCount( self.mViewID )
	end

	function GridView:setFixedColumnCount( rows )
		gridview.setFixedColumnCount( self.mViewID, rows )
	end

	-- w̍s̍擾Eݒ肷
	function GridView:getRowHeight( row )
		return gridview.getRowHeight( self.mViewID, row )
	end

	function GridView:setRowHeight( row, height )
		gridview.setRowHeight( self.mViewID, row, height )
	end

	-- w̗̉擾Eݒ肷
	function GridView:getColumnWidth( col )
		return gridview.getColumnWidth( self.mViewID, col )
	end

	function GridView:setColumnWidth( col, width )
		gridview.setColumnWidth( self.mViewID, col, width )
	end


	-- \XV
	-- row : XVsBnil w肵ꍇ͑ŜXV
	function GridView:update( row )
		gridview.update( self.mViewID, row )
	end

	-- wZ悤ɁAKvȂObhXN[
	function GridView:ensureVisible( row, col )
		gridview.ensureVisible( self.mViewID, row, col )
	end

	-- R[obN֐o^
	function GridView:setCallBack( callbacks )
		gridview.setCallBack( self.mViewID, callbacks )
	end


	-- Cxgnh
	function GridView:onClickCell( row, col )
	end

	function GridView:onDoubleClickCell( row, col )
	end

	function GridView:onRightClickCell( row, col )
	end

	function GridView:onKey( row, col, key )
	end

Class:new( GridView )


-------------------------------------------------------------------------
-- t@CXgr[NX
-------------------------------------------------------------------------
FileListView = { "FileListView", "GridView"; class = {} }

	function FileListView:init( gridViewID )
		self:super( gridViewID )
		self.mFileList = nil			-- t@CXg

		-- Xgr[
		self:clearListView()
	end


	------------------------------------------------------
	-- t@CXg
	------------------------------------------------------
	-- ݒ肳ꂽt@CXgԂ
	function FileListView:fileList()
		return self.mFileList
	end

	-- Vt@CXgݒ肷
	function FileListView:setFileList( fileList )
		if self.mFileList then
			self.mFileList:removeDependent( self )
		end
		-- t@CXgۑ
		self.mFileList = fileList
		fileList:addDependent( self )	-- ˑ֌Wݒ

		-- XĝׂẴ\[XObhr[ɐݒ肷
		self:clearListView()	-- Obhr[NA
		fileList:foreachDescendant(
			function( i, v )
				self:insertRowResource( -1, v )
			end
		)
		print( "rowCount "..self:getRowCount() )

		-- \XV
		self:update()
	end

	-- w̍s̃\[XԂ
	function FileListView:getResource( row )
		if self.mFileList == nil then return nil end
		return self.mFileList:getResourceAt( row )
	end

	-- t@CXg̕ύXʒm
	function FileListView:updateModel( message, ... )
		if message == FileList.kInsertNode then
			-- \[Xǉꂽ
			self:insertRowResource( arg[1], arg[2] )
		elseif message == FileList.kChangeViewResource then
			-- \̃\[XύXꂽ
			self:changeViewResource( arg[1], arg[2] )
		end
	end


	-- Cr[ɕ\̃\[X̕ύXʒm
	function FileListView:changeViewResource( oldRes, newRes )
		local row
		-- \[XsXVN[W
		local updateResourceLine = function( i, res )
			row = res:resourceIndex()
			if row == 0 then return end
			self:setRowData( row, self:createRowData(res) )
			self:update( row )
		end
		-- \ȂȂ郊\[X
		if oldRes then
			oldRes:foreachAncestor( updateResourceLine )
			updateResourceLine( nil, oldRes )
		end
		-- \郊\[X
		if newRes then
			newRes:foreachAncestor( updateResourceLine )
			updateResourceLine( nil, newRes )
			-- Obh̑ΉsK\悤ɂ
			if self:getRowHeight( row ) == 0 then
				-- \ԂȂ̂ŏʃfBNg\
				local ensureParentVisible = function( i, res )
					local row = res:resourceIndex()
					if row == 0 then return end
					if self:getRowHeight( row ) ~= 0 then
						self:ensureVisible( row )
						return true
					end
				end
				newRes:foreachAncestor( ensureParentVisible )
			else
				self:ensureVisible( row )
			end
		end
	end

	------------------------------------------------------
	-- s̒ǉE폜
	------------------------------------------------------
	-- XgɈsǉ
	-- row : }ʒui̍sԍ̎Oɑ}j
	-- res : ǉ郊\[X
	-- ߂l : ǉꂽsԍis nilj
	function FileListView:insertRowResource( row, res )
		-- [hς݃Tuc[ΊJԂɂ
--~ 		if res:isSubTreeLoaded() then
--~ 			res:setSubTreeOpenFlag( true )
--~ 		end

		-- Ps}
		row = self:insertRow( row )

		-- ̃\[X̕\Ԃݒ
		if res:isShown() then
			self:showRow( row )
		else
			self:hideRow( row )
		end

		-- ̍s̃f[^ݒ
		local cells = self:createRowData( res )
		self:setRowData( row, cells )
	end

	-- ws̃\[Xݒ
	-- row : sԍ
	-- res : ǉ郊\[X
	function FileListView:setRowResource( row, res )
		local cells = self:createRowData( res )
		self:setRowData( row, cells )
	end

	-- Xg\̏
	function FileListView:clearListView()
		self:getFixedRowCount( 1 )
		self:getFixedColumnCount( 0 )
		self:setRowCount( 1 )
		self:setColumnCount( 5 )
		local info = {
			cellData( "t@C" ),
			cellData( "TCY" ),
			cellData( "`" ),
			cellData( "[_[" ),
			cellData( "tpX" )
		}
		self:setRowData( 0, info )
		self:update()
	end


	------------------------------------------------------
	-- c[֘A
	------------------------------------------------------
	-- w̍sc[\Ȃ true Ԃ
	function FileListView:isTree( row, res )
		res = res or self:getResource( row )
		return res:hasSubTree()
	end

	-- ws̃c[JĂ true Ԃ
	function FileListView:isTreeOpened( row, res )
		res = res or self:getResource( row )
		return res:isSubTreeOpened()
	end

	-- ws̃c[Ătrue Ԃ
	function FileListView:isTreeClosed( row, res )
		res = res or self:getResource( row )
		return not res:isSubTreeOpened()
	end

	-- ws̃c[J
	-- row : s
	-- res : \[XiĂΎwBȗ\j
	function FileListView:openTree( row, res )
		res = res or self:getResource( row )
		if res == nil or not res:hasSubTree() then
			return
		end

		-- Tuc[[hĂȂ΃[h
		if not res:isSubTreeLoaded() then
			local bOK = res:loadSubTree()
			if not bOK then return end
		end

		-- tOύX
		res:setSubTreeOpenFlag( true )

		-- Obh\̍XV
		if row >= 1 then
			-- c[ACRύX
			local cell = { imageIndex = 2 }
			self:setCellData( row, 0, cell )
			self:update( row )
			print( "openTree() : row:"..row.."" )
		end

		-- c[ẘJĂs\
		local shownRows = res:getShownRows( row )
		shownRows:foreach(
			function(i, v)
				if v[1] >= 1 then
					self:showRow( v[1], v[2] )
				end
			end
		)

		-- \̉摜Ȃꍇ
		if not gData.imageFile then
			-- ŏ̉摜t@CT
			file = gData.fileList:getFirstImage()
			setCurrentImage( file )

			-- ^Cg̃y[W\LXV
			setFrameTitle()
		end

		-- Tuc[ЂƂ̃t@Ĉ͍̂ċAIɊJ
		if res:getNodeCount() == 1 then
			res = res:getChildAt(1)
			if res then
				self:openTree( res:resourceIndex(), res )
			end
		end

	end

	-- ws̃c[
	-- row : s
	-- res : \[XiĂΎwBȗ\j
	function FileListView:closeTree( row, res )
		res = res or self:getResource( row )
		if res == nil or not res:hasSubTree() then
			return
		end

		-- tOύX
		res:setSubTreeOpenFlag( false )

		-- Obh\̍XV
		if row >= 1 then
			-- c[ACRύX
			local cell = { imageIndex = 1 }
			self:setCellData( row, 0, cell )
			self:update( row )
			print( "closeTree() row:"..row.."" )

			-- c[ŵׂĂ̍sB
			self:hideRow( row + 1,  res:getTotalNodeCount() )
		end
	end

	-- ws̃c[J
	-- row : s
	-- res : \[XiĂΎwBȗ\j
	function FileListView:toggleTree( row, res )
		res = res or self:getResource( row )
		if res == nil or not res:hasSubTree() then
			return
		end

		if res:isSubTreeOpened() then
			self:closeTree( row, res )
		else
			self:openTree( row, res )
		end
	end


	------------------------------------------------------
	-- Z̕\
	------------------------------------------------------
	-- w胊\[X̕\f[^쐬ĕԂ
	function FileListView:createRowData( res )
		if res == nil then
			return nil
		end

		-- eZ̑OiF
		local fgColor = { nil, nil, nil, nil, nil }

		-- ̍sJgt@CȂwiFݒ
		local bgColor = "FFFFFF"
		if gData.imageFile then
			if res == gData.imageFile then
				bgColor = "F0F0D0"
			elseif res:isDescendant( gData.imageFile ) then
				-- Jgt@C̒n̏ʃfBNgȂ
				bgColor = "E0E0F0"
			end
		end

		-- t@C^Cv
		local typeName
		local imageLoader = res:imageLoader()
		local archiveLoader = res:archiveLoader()

		if res:isDirectory() then
			typeName = "fBNg"
			fgColor[3] = "50B050"
		else
			if imageLoader then
				typeName = imageLoader:fileTypeName()
				fgColor[3] = "B05050"
			elseif archiveLoader then
				typeName = archiveLoader:fileTypeName()
				fgColor[3] = "5050B0"
			else
				typeName = "-"
				fgColor[3] = "808080"
			end
		end

		-- [_[
		local loader = imageLoader
		local loader2 = archiveLoader
		if loader == nil then loader, loader2 = loader2, nil end
		local loaderName
		if loader then loaderName = loader:loaderName() end
		if loader2 then
			loaderName = loaderName.."  ||  "..loader2:loaderName()
		end

		-- TCYƕF
		local size
		size, fgColor[2] = sizeString(res:size())

		-- }[W
		local margin = (res:getNodeDepth() - 1) * 10 + 3

		-- c[\p̃ACR
		local imageIndex = 0
		if res:hasSubTree() then
			if res:isSubTreeOpened() then
				imageIndex = 2
			else
				imageIndex = 1
			end
		end

		-- ̍s̓eԂ
		return {
			cellData( res:name(), bgColor, fgColor[1], imageIndex, margin ),
			cellData( size, bgColor, fgColor[2] ),
			cellData( typeName, bgColor, fgColor[3] ),
			cellData( loaderName, bgColor, fgColor[4] ),
			cellData( res:path(), bgColor, fgColor[5] )
		}
	end


	------------------------------------------------------
	-- Cxgnh
	------------------------------------------------------
	function FileListView:onClickCell( row, col )
	end

	function FileListView:onDoubleClickCell( row, col )
		local res = self:getResource( row )
		if res and res:hasImageLoader() then
			setCurrentImage(res)
		end
		self:toggleTree( row, res )
	end

	function FileListView:onRightClickCell( row, col )
		print( "onRightClickCell "..row..", "..col )
	end

	function FileListView:onKey( row, col, key )
		print( "onKey "..row..", "..col.." / "..key )
		local oldRow = self:getFocus()

		if key == 32 or key == 13 or key == 39 then
			-- Xy[X^ENTER^EL[̏
			res = self:getResource( row )
			self:openTree( row, res )
			row = row + 1		-- tH[JX̍s֐ݒ肷
			res = self:getResource( row )

			if row < self:getRowCount() then
				self:setFocus( row )
				self:ensureVisible( row, 0 )
			else
				-- t@CXg̖܂ŗ̂Ń_CAO\
--				ShowStopDialog( true )
			end
			if res and res:hasImageLoader() then
				-- 摜ȂJ
				setCurrentImage(res)
			end

		elseif key == 37 then
			-- L[̏
			row = row - 1		-- tH[JX̍s֐ݒ肷
			res = self:getResource( row )
			if res and res:hasImageLoader() then
				-- 摜ȂJ
				setCurrentImage(res)
			end
--			self:openTree( row, res )

			if row < self:getRowCount() then
				self:setFocus( row )
				self:ensureVisible( row, 0 )
			else
				-- t@CXg̖܂ŗ̂Ń_CAO\
--				ShowStopDialog( true )
			end

		elseif key == 8 then
			-- EscL[̏
			res = self:getResource( row )
			if res and res:isSubTreeOpened() then
				-- }JĂΕ
				self:closeTree( row )
				self:setFocus( row )	-- tH[JXݒ肵Ȃ
				self:ensureVisible( row, 0 )
			else
				-- e̎}ֈړ
				local res = res:getParent()
				if res then
					row = res:resourceIndex()
					self:setFocus( row )	-- tH[JXݒ肵Ȃ
					self:ensureVisible( row, 0 )
				end
			end

--~		elseif key == 39 then
--~			-- EL[̏
--~			res = self:getResource( row )
--~			if res and res:hasImageLoader() then
--~				-- 摜Ȃ\
--~				setCurrentImage(res)
--~			end
--~			-- }ȂJ
--~			self:openTree( row, res )
--~			self:setFocus( row )	-- tH[JXݒ肵Ȃ
		end

	end

Class:new( FileListView )


-------------------------------------------------------------------------
-- end of file
-------------------------------------------------------------------------
end_declare()