-------------------------------------------------------------------------
-- FileType
--
-- $Id: FileType.lua,v 1.6 2005/08/17 14:26:15 okayu Exp $
-------------------------------------------------------------------------
LUA_PATH = "./?.lua;./LuaClass/?.lua"
require "LuaClass"

-- Class name declarations.
begin_declare()
declare("FileType")


-------------------------------------------------------------------------
-- t@C^Cv
-------------------------------------------------------------------------
FileType = { "FileType"; class = {}; }

	function FileType:init( extension )
		self.mLoaders = Array()		-- ̃^CvɑΉ[_[
		self.mExtension = extension
	end

	function FileType:extension()
		return self.mExtension
	end

	-- 摜[_[̃Ce[^֐Ԃ
	function FileType:imageLoaders()
		local iterator = function( _s )
			local count = _s.fileType.mLoaders:size()
			while _s.index <= count do
				local loader = _s.fileType.mLoaders:at( _s.index )
				_s.index = _s.index + 1
				if loader and loader:isKindOf(ImageLoader) then
					return loader
				end
			end
		end
		local _s = { index = 1, fileType = self }
		return iterator, _s
	end

	-- A[JCu[_[̃Ce[^֐Ԃ
	function FileType:archiveLoaders()
		local iterator = function( _s )
			local count = _s.fileType.mLoaders:size()
			while _s.index <= count do
				local loader = _s.fileType.mLoaders:at( _s.index )
				_s.index = _s.index + 1
				if loader and loader:isKindOf(ArchiveLoader) then
					return loader
				end
			end
		end
		local _s = { index = 1, fileType = self }
		return iterator, _s
	end

	-- 摜[_[݂΁Aŏ̃[_[Ԃ
	function FileType:firstImageLoader()
		local loader
		for loader in self:imageLoaders() do
			return loader
		end
		return nil
	end

	-- A[JCu[_[݂΁Aŏ̃[_[Ԃ
	function FileType:firstArchiveLoader()
		local loader
		for loader in self:archiveLoaders() do
			return loader
		end
		return nil
	end

	-- 摜[_[݂΁Atrue Ԃ
	function FileType:hasImageLoader()
		local loader
		for loader in self:imageLoaders() do
			return true
		end
		return false
	end

	-- A[JCu[_[݂΁Atrue Ԃ
	function FileType:hasArchiveLoader()
		local loader
		for loader in self:archiveLoaders() do
			return true
		end
		return false
	end

	function FileType:addLoader( loader )
		self.mLoaders:add( loader )
	end


	------------- NX\bh -------------

	function FileType.class:init()
		self.mFileTypes = Dictionary();	-- t@C^CviL["bmp" "lzh"̂悤ȏ̊gqj
	end

	-- w̃\[XT|[gĂ^CvԂ
	function FileType.class:findFileType( filename )
		local title, extension = app.splitExtension( filename )
		extension = string.lower( extension )
		return self.mFileTypes:at( extension )
	end

	-- [_[̑Ήgqt@C^CvɊ֘At
	-- ́A"*.tgz;*.taz;*.z"̂悤Ȋgq̕
	function FileType.class:registerLoader( loader, extString )
		local it = string.gfind( extString, "\*\.([^;]*)" )
		local extension
		for extension in it do
			extension = string.lower( extension )
			local fileType = self.mFileTypes:at( extension )
			if fileType == nil then
				fileType = FileType(extension)
				self.mFileTypes:add( extension, fileType )
			end
			fileType:addLoader( loader )
		end
	end
	
	-- ׂẲ摜^CvRNVƂĕԂ
	function FileType.class:imageTypes()
		local typeSet = Set()
		self.mFileTypes:foreach(
			function(i, v)
				if v:hasImageLoader() then typeSet:add(v) end
			end
		)
		return typeSet
	end

	-- ׂẴA[JCu^CvRNVƂĕԂ
	function FileType.class:archiveTypes()
		local typeSet = Set()
		self.mFileTypes:foreach(
			function(i, v)
				if v:hasArchiveLoader() then typeSet:add(v) end
			end
		)
		return typeSet
	end

Class:new( FileType )



-------------------------------------------------------------------------
-- end of file
-------------------------------------------------------------------------
end_declare()