local appStartTime = app.getTicks()

LUA_PATH = "./?.lua;./LuaClass/?.lua"
require "LuaClass"
require "Tree"
require "LuaUnit"
require "CacheDictionary"

require "FileType"
require "FileLoader"
require "Resource"
require "FileList"
require "FileListView"

require "api_test"


-------------------------------------------------------------------------
-- AvP[VNX
-------------------------------------------------------------------------
Application = { "Application"; class = {}; }

	function Application:init()
		-- CxgnhR[obN֐Ƃēo^
		app.setCallBack {
			onInit = self:bind( self.onInit );
			onExit = self:bind( self.onExit );
		}
	end

	function Application:onInit()
	end

	function Application:onExit()
	end


Class:new( Application )


--~ MenuCommand

--~ mainMenu = {
--~ 	Menu { "t@C(&F)",
--~ 		MenuCommand { handler = self:bind(self.doOpenFile),
--~ 				name = "t@CJ(&O)...\tCtrl+O",
--~ 				prompt = "t@CIĊJ" };
--~ 		MenuCommand { handler = self:bind(self.doOpenFolder),
--~ 				name = "tH_J...(&F)\tCtrl+F",
--~ 				prompt = "tH_IĊJ" };
--~ 		MenuCommand { handler = self:bind(self.doExit),
--~ 				name = "I(&X)",
--~ 				prompt = "AvP[V̏I" };
--~ 	};
--~ 	Menu { "ҏW(&E)",
--~ 		MenuCommand { handler = self:bind(self.doCopy),
--~ 				name = "Rs[(&C)\tCtrl+C",
--~ 				prompt = "I͈͂Rs[ăNbv{[hɕۑ" };
--~ 	};
--~ }


function checkBufferCache( cacheDict )
	if cacheDict:size() >= 1 then
		-- LbVő吔𒴂̂ōŏ̂̂폜
		cacheDict.mData:popFront()
		collectgarbage()
	end
end

function checkArchiveBufferCache( cacheDict )
	local size = 0
	cacheDict:foreach(
		function( i, v )
			if v == nil then return end
			size = size + v:size()
		end
	)
	print( "checkBufferCache  LbVTCYF"..size )

	if cacheDict:size() >= 3 then
		-- LbVő吔𒴂̂ōŏ̂̂폜
		cacheDict.mData:popFront()
		collectgarbage()
	end
end


-------------------------------------------------------------------------
-- Ǘpϐ
-------------------------------------------------------------------------
gData = {
	imageSurface = nil;			-- \pT[tFX
	bgSurface = nil;			-- wipT[tFX

	fileList = nil;				-- t@CXg

	imageFile = nil;			-- ݂̉摜t@CiFile IuWFNgj

	currentBgFileName = nil;	-- ݂̔wit@CiEXEt@C̑΃pXj
	currentBgColor = nil;		-- ݂̔wiF

	fileListView = nil;			-- t@CXgpObhr[

	iniFileVersion = 1.0;		-- ݒt@C̃o[W
	fileListFileVersion = 1.0;	-- t@CXgt@C̃o[W

	bufferCache = CacheDictionary( checkBufferCache );
								-- t@C̃obt@LbV
	archiveBufferCache = CacheDictionary( checkBufferCache );
								-- A[JCut@Cobt@̃LbV

	startupOpenLastFile = true;	-- NɑÕt@CǂݍނH
	showStopDialog = true;		-- Xg܂ŗ₢킹_CAO\邩H
}



-------------------------------------------------------------------------
-- ݒ
-------------------------------------------------------------------------
-- AvP[V
app_name = "KomatsunaViewer"

-- EXEt@C̃pX
app_path = app.getApplicationPath()

-- }ChLg̃pX
myDocument_path = app.getSpecialFolder( "PERSONAL" )

-- XNvgtH_
script_path = app.joinPath( app_path, "script" )

-- vOCtH_
pluginPath = app.joinPath( app_path, "plugin" )

-- ݒt@C
iniFileName = app.joinPath( app_path, "setting.lua" )

-- t@CXgt@C
listFileName = app.joinPath( app_path, "filelist.lua" )

-- wi摜
bgPatternFileName = "res\\pattern.bmp"


-------------------------------------------------------------------------
-- ֐
-------------------------------------------------------------------------

function OK_FAIL( bOK )
	if bOK then return "OK" end
	return "FAILURE"
end

function pathToFilename( path )
	local dir, name = app.splitPath( path )
	return name
end

-- SPIvOCǉ
function addSPIPulgin( pluginPath )
	local plugin = app.loadSusiePlugin( pluginPath )
	if plugin == nil then return end
	local version = plugin:getPluginInfo(1)

	if version == "00IN" then
		-- 摜t@CǂݍݗpIuWFNg
		SPILoader:new( pluginPath, plugin )

	elseif version == "00AM" then
		-- A[JCut@CǂݍݗpIuWFNg
		SPIArchiveLoader:new( pluginPath, plugin )

	else
		-- Ή̃vOC^Cv
		plugin:unload()
	end
end


-- wpXSPIvOCĒǉ
function addSPIPulginPath( dir )
	local spi_list = app.findFile( app.joinPath(dir, "*.SPI") )
	table.foreach( spi_list,
		function(i, v)
			addSPIPulgin( app.joinPath(dir, v) )
		end
	)
end


-- 摜t@Cobt@cha[h
function createDibBuffer( file )
	if file == nil then return nil end
	print( "createDibBuffer" )

	local fileType = FileType:findFileType( file:path() )
	if fileType == nil then
		print( "Unknown file type : "..file:path() )
		return nil
	end

	local buffer = file:cachedBuffer()
	if buffer == nil then
		print( "Cannot load file "..file:path() )
		return nil
	end

	for loader in fileType:imageLoaders() do
--~ 		if loader:isSupported( file ) then
		local infoBuffer, bitsBuffer = loader:getPicture( buffer )
		print( "load DibBuffer" )

		if infoBuffer and bitsBuffer then
			return infoBuffer, bitsBuffer
		end
		if infoBuffer then infoBuffer:release() end
		if bitsBuffer then bitsBuffer:release() end
	end

	print( "Cannot load bitmap "..file:path() )
	return nil
end


-- 摜t@Cobt@T[tFX[h
function createFileSurface( file )
	local surface
	local infoBuffer, bitsBuffer = createDibBuffer( file )

	if infoBuffer and bitsBuffer then
		surface = app.createSurface(infoBuffer, bitsBuffer)
	end

	if infoBuffer then infoBuffer:release() end
	if bitsBuffer then bitsBuffer:release() end
	return surface
end


-- CEChẼ^Cgݒ
function setFrameTitle()
	if gData.imageFile then
		local index = onGetCurrentIndex()
		local size = onGetListSize()
		local cx, cy, bpp = 0, 0, 0
		if gData.imageSurface then
			cx = gData.imageSurface:width()
			cy = gData.imageSurface:height()
			bpp = gData.imageSurface:bpp()
		end

		local title = gData.imageFile:name()
			.." [ "..index.." / "..size.." ] "
			.." - "..app.getApplicationName()
			.." ("..cx.."x"..cy..")"
		if gData.imageSurface == nil then
			title = "[hs "..title
		end
		app.setFrameTitle( title )
	else
		app.setFrameTitle( app.getApplicationName() )
	end
end


-- w̃t@CJg摜ɐݒ肷
function setCurrentImage( file )
	local surface = createFileSurface( file )

	-- ϐݒ
	local oldFile = gData.imageFile
	gData.imageFile = file
	gData.imageSurface = surface

	-- 摜T[tFXݒ
	local bOK = app.setImage( surface )

	-- CEChẼ^Cgݒ
	setFrameTitle()

	-- t@CXgɒʒm
	if gData.fileList then
		gData.fileList:changeCurrentImage( oldFile, gData.imageFile )
	end

	-- Lǂ̂ŃS~W
	collectgarbage()

	return bOK
end

-- w̃t@Cwi摜ɐݒ肷
-- filename : t@CiEXEt@C̑΃pXj
function setCurrentBgImage( fileName )
	if fileName == gData.currentBgFileName then
		return false
	end
	local file = File( app.joinPath(app_path, fileName) )
	local surface = file and createFileSurface( file )
	gData.bgSurface = surface
	gData.currentBgFileName = fileName

	-- wi摜T[tFXݒ
	local bOK = app.setBgImage( gData.bgSurface )

	print( "set current bg image "..OK_FAIL(bOK).." : "..fileName )
	return bOK
end

-- wiFݒ肷
function setCurrentColor( color )
	color = color or "FFFFFF"
	app.setBgColor( color )

	-- wi摜T[tFX
	gData.currentBgFileName = nil
	if gData.bgSurface then
		gData.bgSurface:release()
		gData.bgSurface = nil
	end
end

-- wt@CJx_CAO\
function showFileOpenDialog()
	-- gqtB^쐬
	local s = "", typeString
	local imageType, archiveType
	local collectTypes = function(i,v)
		if s ~= "" then s = s..";" end
		s = s.."*."..v:extension()
	end

	local types = FileType:imageTypes()
	types:foreach( collectTypes )
	imageType = s
	s = ""

	types = FileType:archiveTypes()
	types:foreach( collectTypes )
	archiveType = s

	s = imageType..archiveType
	typeString = "ׂĂ̑Ήt@C ("..s..")|"..s.."|"
	typeString = typeString.."摜t@C ("..imageType..")|"..imageType.."|"
	typeString = typeString.."A[JCu ("..archiveType..")|"..archiveType.."|"
	typeString = typeString.."ׂẴt@C (*.*)|*.*||"

	-- _CAO\
	local ret = app.showFileOpenDialog( nil, typeString, true )
	return ret
end

-- wtH_Jx_CAO\
function showFolderOpenDialog()
	local ret = app.showFolderOpenDialog( "tH_IĂ" )
	return ret
end

-- wpX̃t@C݂ true Ԃ
function isFileExist( filepath )
	local found = app.findFile( filepath )
	if table.getn( found ) ~= 0 then return true end
	return false
end

-- NɃEChEʂɂ܂悤`𒲐
function norarizeWindowRect( rect )
	local cx, cy = app.getDesktopSize()
	rect = rect or {}
	rect.x = rect.x or (cx / 2 - 640 / 2)
	rect.y = rect.y or (cy / 2 - 560 / 2)
	rect.cx = rect.cx or 640
	rect.cy = rect.cy or 560
	rect.x = math.max(0, math.min(rect.x, cx - 100))
	rect.y = math.max(0, math.min(rect.y, cy - 100))
	rect.cx = math.max(100, math.min(rect.cx, cx))
	rect.cy = math.max(100, math.min(rect.cy, cy))
	return rect
end


-------------------------------------------------------------------------
-- ݒt@C̓ǂݏ
-------------------------------------------------------------------------

-- ݒt@Cǂݍ
function loadIniFile( filepath )

	print( "ݒt@Cǂݍ݁F"..filepath )
	-- t@Cǂݍ
	local ini
	if isFileExist( filepath ) then
		ini = app.separateDoFile( filepath )
	end
	ini = ini or {}

	-- AvEݒt@Co[W`FbN
	ini.app_name = ini.app_name or app_name
	ini.ini_version = ini.ini_version or gData.iniFileVersion
	if ini.app_name ~= app_name then return false end
	if ini.ini_version > gData.iniFileVersion then return false end

	-- EChE`ݒ
	app.setWindowRect("main", norarizeWindowRect(ini.mainWindowRect) )
	app.setWindowRect("filelist", norarizeWindowRect(ini.filelistWindowRect) )
	app.setWindowRect("console", norarizeWindowRect(ini.consoleWindowRect) )
	app.setWindowRect("workspace", norarizeWindowRect(ini.workspaceWindowRect) )

	-- CEChEԂ𕜌
	app.setMainWindowMode( ini.windowMode )

	-- wiݒ
	local bOK = false
	if ini.bgImage then
		bOK = setCurrentBgImage( ini.bgImage )
	elseif ini.bgColor == nil then
		bOK = setCurrentBgImage( bgPatternFileName )
	end
	if not bOK then
		local color = ini.bgColor or "FFFFFF"
		app.setBgColor( color )
	end

	-- ̑ݒݒ
	app.setWheelRate( ini.wheelRate )
	app.setUseLinearFilter( ini.useLinearFilter )
	app.setViewScaling( ini.scaleRate )

	if ini.startupOpenLastFile == nil then
		ini.startupOpenLastFile = true
	end
	if ini.showStopDialog == nil then
		ini.showStopDialog = true
	end

	gData.startupOpenLastFile = ini.startupOpenLastFile
	gData.showStopDialog = ini.showStopDialog

	-- TCYݒ
	ini.adustMode = ini.adustMode or "width"
	app.setAdustMode( ini.adustMode )

	-- t@Cr[̗񕝂𕜌
	local i
	local defaultColSizes = { 120, 54, 60, 52, 120, }
	ini.fileViewColumnSize = ini.fileViewColumnSize or {}
	for i=1, table.getn( defaultColSizes ) do
		gData.fileListView:setColumnWidth( i - 1,
			ini.fileViewColumnSize[i] or defaultColSizes[i] )
	end

	print( "ݒt@Cǂݍ݊" )
	return true
end


-- ݒt@Cۑ
function saveIniFile( filepath )
	local file = io.open( filepath, "w" )
	if file == nil then return false end

	file:write( '-- ؉r[A ݒf[^\n\n' )
	file:write( 'return {\n' )
	file:write( '  app_name="'..app_name..'";\n' )
	file:write( string.format('  ini_version=%.2f;\n\n', gData.iniFileVersion) )

	-- EChE`ۑ
	local rects = {}
	local windowsMode = app.getMainWindowMode()
	if windowsMode == "normal" then
		rects.mainWindowRect = app.getWindowRect( "main" )
	else
		rects.mainWindowRect = app.getWindowRect( "restoredMain" )
	end
	rects.filelistWindowRect = app.getWindowRect( "filelist" )
	rects.consoleWindowRect = app.getWindowRect( "console" )
	rects.workspaceWindowRect = app.getWindowRect( "workspace" )
	table.foreach( rects,
		function( idx, aRect )
			file:write( '  '..idx..' = {\n' )
			table.foreach( aRect,
				function( i, v ) file:write( '    '..i..' = '..v..',\n' ) end
			)
			file:write( '  };\n' )
		end
	)

	-- CEChEԂۑ
	if windowsMode == "minimized" then windowsMode = "normal" end
	file:write( '  windowMode = "'..windowsMode..'";\n' )

	-- t@Cr[̊e񕝂ۑ
	local view = gData.fileListView
	local i
	file:write( '  fileViewColumnSize = {\n    ' )
	for i = 0, view:getColumnCount() - 1 do
		file:write( view:getColumnWidth(i)..', ' )
	end
	file:write( '\n  };\n' )

	-- wiۑ
	if app.getBgImage() ~= nil then
		file:write( '  bgImage = '..app.safeLiteral(gData.currentBgFileName)..';\n' )
	else
		file:write( '  bgColor = "'..app.getBgColor()..'";\n' )
	end

	-- TCYݒۑ
	local adustMode = app.getAdustMode()
	if adustMode then
		file:write( '  adustMode = "'..adustMode..'";\n' )
	end

	-- ̑ݒۑ
	file:write( string.format('  wheelRate = %.2f;\n', app.getWheelRate()) )
	file:write( string.format('  scaleRate = %.2f;\n', app.getViewScaling()) )
	file:write( '  useLinearFilter = '..tostring(app.getUseLinearFilter())..';\n' )
	file:write( '  startupOpenLastFile = '..tostring(gData.startupOpenLastFile)..';\n' )
	file:write( '  showStopDialog = '..tostring(gData.showStopDialog)..';\n' )

	file:write( '}\n' )
	file:close()
	return true
end


-- t@CXgǂݍ
function loadFileList( filepath )

	print( "t@CXgǂݍ݁F"..filepath )

	-- t@Cǂݍ
	local list
	local basePath
	if isFileExist( filepath ) then
		list = app.separateDoFile( filepath )
	end
	if list == nil or list.root == nil then
		onNewFileList()
		return false
	end

	-- AvEݒt@Co[W`FbN
	list.app_name = list.app_name or app_name
	list.ini_version = list.ini_version or gData.iniFileVersion
	if list.app_name ~= app_name then return false end
	if list.filelist_version > gData.fileListFileVersion then return false end
	if list.relativePath then basePath = app.splitPath( filepath ) end

	-- fVACY
	local fileList = FileList()
	fileList:deserialize( list.root, basePath )

	-- Vt@CXgǉ
	setFileList( fileList, list.currentFile )

	print( "t@CXgǂݍ݊" )
	return true
end


-- t@CXgۑ
function saveFileList( filepath )
	local file = io.open( filepath, "w" )
	if file == nil then return false end

	file:write( '-- ؉r[A t@CXgf[^\n\n' )
	file:write( 'return {\n' )
	file:write( '  app_name="'..app_name..'";\n' )
	file:write( string.format('  filelist_version=%.2f;\n', gData.fileListFileVersion) )

	-- ݂̃t@C
	if gData.imageFile then
		file:write( '  currentFile='..app.safeLiteral(gData.imageFile:path())..';\n' )
	end

	-- VACY
	file:write( '\n  root=\n' )
	gData.fileList:serialize( file, nil, 1 )

	file:write( '}\n' )
	file:close()
	return true
end


-------------------------------------------------------------------------
-- Cxgnh
-------------------------------------------------------------------------
local window

-- 
-- files   Nɓnꂽt@C̃e[u
function onInitializeApp( files )
	print( "initialize app" )

	-- wiFݒ
	app.setBgColor("FFFFFF")

	-- CEChẼ^Cgݒ
	app.setFrameTitle( app.getApplicationName() )

	-- t@CXgr[
	local viewId = gridview.getFileListID()
	gData.fileListView = FileListView( viewId )

	-- SPIvOCpXǉ
	addSPIPulginPath( pluginPath )

	-- rgC[_[ǉ
	BuiltinBmpLoader:new()
	BuiltinJpegLoader:new()

	-- ݒt@Cǂݍ
	loadIniFile( iniFileName )

	-- }CfBNgJgtH_ɐݒ
	app.setCurrentDirectory( myDocument_path )

	-- t@CXg
	onNewFileList()
	if table.getn(files) ~= 0 then
		-- NɃt@CnꂽꍇAJ
		addFile( files )
	else
		-- PɋNꍇ
		if gData.startupOpenLastFile then
			-- Õt@CXgǂݍ
			loadFileList( listFileName )
		end
	end

	app.setStatusText( "NԁF"..((app.getTicks() - appStartTime) / 1000).."b" )

	-- eXgp
	api_test()

--[[
	-- vOXEChẼeXg
	local callback1 = function()
		print( "R[obN1Ă΂ꂽ" )
	end
	local callback2 = function()
		print( "R[obN2Ă΂ꂽ" )
	end
	window = app.createProgressWindow( callback1 )
	window:setTitle( "" )
	window:setMessage( "ł" )
	window:setProgressPos( 100 )
	window:show()
--]]

end


-- I
function onReleaseApp()
	print( "release app" )

	-- EChȄԂۑ
	saveIniFile( iniFileName )

	-- t@CXgۑ
	saveFileList( listFileName )
end



-- VKt@CXg
function onNewFileList( files )
	print( "onNewFileList" )
	setCurrentImage( nil )
	gData.fileList = FileList()
	gData.fileListView:setFileList( gData.fileList )
	setFrameTitle()
end


-- t@CXgXV
function updateFileList( firstFilePath )
	if gData.fileList == nil then return end
		print( "updateFileList" )

	-- ŏ̃t@C\
	local file = nil
	if firstFilePath then
		-- w̃pX̃t@CT
		file = gData.fileList:findPath( firstFilePath )
	end

	-- ŏ̃t@CJ
	file = file or gData.fileList:getFirstImage()
	setCurrentImage( file )

	-- JgfBNg̃t@C̃fBNgɕύX
	local path
	if file then path = file:fsFilePath() end
	while file ~= nil and path == nil do
		-- A[JCut@CȂA[JCut@C̃fBNg
		file = file:containerFile()
		path = file:fsFilePath()
	end
 	local parentDirectory = app.splitPath( path )
	app.setCurrentDirectory( parentDirectory )

	-- CEChẼ^Cgݒ肵Ȃ
	setFrameTitle()

	-- t@CXgr[XV
	gData.fileListView:update()
end


-- Vt@CXgǉ
function setFileList( fileList, firstFilePath )
	-- qm[hЂƂȂꍇ̓Tuc[ǂݍ
	if fileList:getNodeCount() == 1 then
		local child = fileList:getChildAt(1)
		if child then
			child:loadSubTree()
			child:setSubTreeOpenFlag( true )
		end
	end

	-- Tuc[ЂƂ̃t@Ĉ͍̂ċAIɊJ
	local tmp = fileList
	while tmp do
		tmp:setSubTreeOpenFlag( true )
		if tmp:getNodeCount() >= 2 then break end
		tmp = tmp:getChildAt(1)
	end

	-- t@CXgr[ɐݒ
	gData.fileList = fileList
	gData.fileListView:setFileList( gData.fileList )
	collectgarbage()

	-- t@CXgXV
	updateFileList( firstFilePath )
end


-- t@CXgɒǉłt@CH
function isListTargetFile( fileInfo )
	if fileInfo == nil then
		return false
	end
	if fileInfo.isFile then
		-- t@C^Cvo^Ȃgq̏ꍇ͒ǉȂ
		local fileType = FileType:findFileType( fileInfo.filepath )
		if fileType == nil then
			return false
		end
	end
	return true
end


-- ̉摜t@CT
function getNextFile()
	local file = gData.imageFile
	repeat
		file = file:nextNode()
		if file == nil then break end
	until file:isFile() and file:hasImageLoader()
	return file
end

-- ЂƂỎ摜t@CT
function getPrevFile()
	local file = gData.imageFile
	repeat
		file = file:prevNode()
		if file == nil then break end
	until file:isFile() and file:hasImageLoader()
	return file
end


-- t@CXgɃt@Cǉ
-- files   ǉt@C̃e[u
function addFile( files )
	print( "addFile" )
	if table.getn(files) == 0 then
		return
	end

	local firstFilePath = nil
	local fileArray = Array()

	if table.getn(files) == 1 then
		-- t@CЂƂ̏ꍇ
		-- t@C擾
		local info = app.getFileInfo( files[1] )
		if not isListTargetFile( info ) then return end

		-- t@C̏ꍇ̏u
		if info and info.isFile then
			local fileType = FileType:findFileType( info.filepath )
			local doesSubTree = (fileType ~= nil) and
				(not fileType:hasImageLoader()) and fileType:hasArchiveLoader()

			if doesSubTree then
				-- 摜[_[ȂA[JCu[_[t@C̏ꍇ́A
				-- fBNgƓlɈ̂łȂɂȂ
			else
				-- ȊOȂAw̃fBNgJ
				firstFilePath = files[1]
				local dir = app.splitPath( files[1] )
				info = app.getFileInfo( dir )
			end
		end

		-- w̃t@C^fBNgJ
		local file = Resource:newFSFile( info )
		if file == nil then return end

		-- Tuc[J
		file:loadSubTree()
		-- Tuc[ЂƂ̃t@Ĉ͍̂ċAIɊJ
		local tmp = file
		while tmp do
			tmp:setSubTreeOpenFlag( true )
			if tmp:getNodeCount() >= 2 then break end
			tmp = tmp:getChildAt(1)
		end
		-- Xgǉ
		fileArray:add( file )

	else
		-- ̃t@C̏ꍇ
		-- t@C̃XgɃt@Cc[̃Xg쐬
		table.foreach( files,
			function(i, v)
				local info = app.getFileInfo( v )
				local file = info and Resource:newFSFile( info )
				if file then
					-- fBNgȂTuc[J
					if file:isDirectory() then
						file:loadSubTree()
						file:setSubTreeOpenFlag( true )
					end
					-- Xgǉ
					fileArray:add( file )
				end
			end
		)
	end

	-- W߂t@Ct@CXgɂ܂Ƃ߂Ēǉ
	fileArray:foreach(
		function (i, v)
			gData.fileList:addNode( v )
		end
	)

	-- t@CXgXV
	updateFileList( firstFilePath )

	-- JgfBNgŏ̃t@C̃fBNgɕύX
 	local parentDirectory = app.splitPath( files[1] )
	app.setCurrentDirectory( parentDirectory )

end


-- t@CXg̐擪^܂ŗꍇ̃_CAO\
-- isEnd : Ȃ true
function ShowStopDialog( isEnd )

	-- _CAO\ȂݒȂ擪^
	if not gData.showStopDialog then
		if isEnd then
			-- ŏ̉摜t@Cֈړ
			file = gData.fileList:getFirstImage()
			setCurrentImage( file )
		else
			-- Ō̉摜t@Cֈړ
			file = gData.fileList:getLastImage()
			setCurrentImage( file )
		end
		return
	end

	-- _CAO{^pN[W
	local selected
	optionFunc1 = function()
		selected = showFileOpenDialog()
		if not selected then return nil end
		return "FILE"
	end
	optionFunc2 = function()
		selected = showFolderOpenDialog();
		if not selected then return nil end
		return "FOLDER"
	end

	-- _CAObZ[W
	local message
	if isEnd then
		message = "ȏt@C܂B\nŏ̃t@Cɖ߂܂H"
	else
		message = "ȏt@C܂B\nŌ̃t@CɈړ܂H"
	end

	-- _CAO\
	ret = app.showOptionalDialog(
		"mF", message,
		"ʂ̃t@CJ", optionFunc1, "ʂ̃tH_J", optionFunc2 )

	-- [Ủ
	if ret ==  "OK" then
		if isEnd then
			-- ŏ̉摜t@Cֈړ
			file = gData.fileList:getFirstImage()
			setCurrentImage( file )
		else
			-- Ō̉摜t@Cֈړ
			file = gData.fileList:getLastImage()
			setCurrentImage( file )
		end
	elseif ret == "CANCEL" then
		-- ̂܂܂Ŗ߂
	elseif ret == "FILE" then
		-- t@CJ
		onNewFileList()
		addFile( selected )
	elseif ret == "FOLDER" then
		-- tH_J
		onNewFileList()
		addFile( { selected } )
	end
end


-- ̉摜t@C\v
function onNextImage()

	-- ̉摜t@CΕ\
	if gData.imageFile then
		local file = getNextFile()
		if file then
			-- 摜t@Cݒ
			setCurrentImage( file )
			return
		end
	end

	-- t@CXg̖܂ŗ̂Ń_CAO\
	ShowStopDialog( true )
end

-- ЂƂỎ摜t@C\v
function onPrevImage()

	-- ЂƂỎ摜t@CΕ\
	if gData.imageFile then
		local file = getPrevFile()
		if file then
			-- 摜t@Cݒ
			setCurrentImage( file )
			return
		end
	end

	-- t@CXg̖܂ŗ̂Ń_CAO\
	ShowStopDialog( false )
end


-- t@Cǉv
function onAddFile( files )
	addFile( files )
end


-- ݂̕\t@Cv
function onGetCurrentFilename()
	if gData.imageFile == nil then return "" end
	return gData.imageFile:path()
end

-- ݂̕\CfbNXv
function onGetCurrentIndex()
	local file = gData.imageFile
	if file == nil then return 0 end
	return file:countPrevMarks() + 1
end

-- Xg̃TCYv
function onGetListSize()
	if gData.fileList == nil then return 0 end
	return gData.fileList:getTotalMarkCount()
end


-- j[nhw`FbN͗lx
function onSetBgCheckMenu()
	setCurrentBgImage( bgPatternFileName )
end

-- wiFύXj[nh
function onSetBgColor( color )
	setCurrentColor( color )
end

-- j[nhwt@CJx
function onOpenFile()
	local files = showFileOpenDialog();
	if files then
		-- t@CXg쐬
		onNewFileList()
		addFile( files )
	end
end

-- j[nhwtH_Jx
function onOpenFolder()
	local dir = showFolderOpenDialog();
	if dir then
		-- t@CXg쐬
		onNewFileList()
		addFile( { dir } )
	end
end

-- j[nhwt@Cۑx
function onSaveFile()
	print( "onSaveFile()" )
	if gData.imageSurface == nil or gData.imageFile == nil then
		return
	end

	local title, ext = app.splitExtension( gData.imageFile:name() )
	if ext then ext = string.lower( ext ) end

	-- ۑ_CAO\
	local defFilename = title
	local defExt = ext
	local typeString = "Bitmap (*.bmp)|*.bmp"
	if ext then typeString = ext.." (*."..ext..")|*."..ext.."|"..typeString end
	print( "ext : "..typeString )
	local ret = app.showFileSaveDialog( nil, defFilename, defExt, typeString );
	if ret == nil then return end

	-- ۑt@CJ
	local file = io.open( ret, "wb" )
	if file == nil then return end

	-- gqmF
	local title, choiceExt = app.splitExtension( ret )

	-- 
	if choiceExt == ext then
		-- ̂܂܂̊gqŕۑ
		local buffer = gData.imageFile:cachedBuffer()
		buffer:ioWrite( file )
	else
		-- Bitmapt@CƂĕۑ
		local infoBuffer, bitsBuffer = createDibBuffer( gData.imageFile )
		local headerBuffer = app.createBmpFileHeader( infoBuffer )
		if infoBuffer and bitsBuffer and headerBuffer then
			-- 
			headerBuffer:ioWrite( file )
			infoBuffer:ioWrite( file )
			bitsBuffer:ioWrite( file )
		end
	end
	file:close()

end

function onUpdate_saveFile()
	-- wt@Cۑxgp\Ȃtrue
	if gData.imageSurface == nil or gData.imageFile == nil then
		return false, false
	end
	return true, false
end

-- j[nhwRs[x
function onEditCopy()
	app.setClipboardData( gData.imageSurface )
end

function onUpdateEditCopy()
	return (gData.imageSurface ~= nil), false
end

-- j[nhwNɑÕt@CJx
function onStartupOpenLastFile()
	gData.startupOpenLastFile = not gData.startupOpenLastFile
end

function onUpdate_startupOpenLastFile()
	return true, gData.startupOpenLastFile
end

-- j[nhwXgŃ_CAO\x
function onShowStopdialog()
	gData.showStopDialog = not gData.showStopDialog
end

function onUpdate_showStopdialog()
	return true, gData.showStopDialog
end

-- ĕ`nh
-- ݖ
function onDraw()
	if gData.imageSurface then
		app.drawScreen( gData.imageSurface )

--		print( "buffer :"..tostring(buffer).."  pitch :"..pitch..
--			" width:"..gData.imageSurface:width().."  height:"..gData.imageSurface:height() )
	end
end

